'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _fs = require('./fs');

var _helpers = require('./helpers');

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { return step("next", value); }, function (err) { return step("throw", err); }); } } return step("next"); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var State = function () {
  function State(state, config, stateFile, configFile) {
    _classCallCheck(this, State);

    this.state = state;
    this.config = config;
    this.stateFile = stateFile;
    this.configFile = configFile;
  }

  _createClass(State, [{
    key: 'get',
    value: function get() {
      return this.state;
    }
  }, {
    key: 'getConfig',
    value: function getConfig() {
      return this.config;
    }
  }, {
    key: 'write',
    value: function () {
      var ref = _asyncToGenerator(function* () {
        yield (0, _fs.writeJSON)(this.stateFile, this.state, true);
        yield (0, _fs.writeJSON)(this.configFile, this.config, true);
      });

      function write() {
        return ref.apply(this, arguments);
      }

      return write;
    }()
  }], [{
    key: 'create',
    value: function () {
      var ref = _asyncToGenerator(function* (stateFile, configFile) {
        var stateFileExists = yield (0, _fs.exists)(stateFile);
        var configFileExists = yield (0, _fs.exists)(configFile);
        var state = stateFileExists ? yield (0, _fs.readJSON)(stateFile) : {
          running: false,
          process_id: process.pid,
          web_server_port: (0, _helpers.getRandomNumber)(8090, 9500),
          npm_save: true
        };
        var config = configFileExists ? yield (0, _fs.readJSON)(configFile) : {
          include_polyfills: false
        };

        return new State(state, config, stateFile, configFile);
      });

      function create(_x, _x2) {
        return ref.apply(this, arguments);
      }

      return create;
    }()
  }]);

  return State;
}();

exports.default = State;
//# sourceMappingURL=state.js.map